Test2::Harness::Runner::DepTracer(3pm)

NAME
Test2::Harness::Runner::DepTracer - Tool for tracing module dependencies as they are loaded.

DESCRIPTION
This tool is used by Test2::Harness to build a graph of dependancies which can then be used to blacklist modified modules (and anything thatuses them) when they change under a preloaded runner.

SYNOPSIS
    use Test2::Harness::Runner::DepTracer;

    my $dt = Test2::Harness::Runner::DepTracer->new();

    $dt->start();

    require Some::Thing;

    # You can always check for and retrieve an active DepTrace this way:
    my $dt_reference = Test2::Harness::Runner::DepTracer->ACTIVE;

    $dt->stop();

    my $dep_map = $dt->dep_map;

    my $loaded_by = $dep_map->{'Some/Thing.pm'};
    print "Some::Thing was directly or indirectly loaded by:\n" . join("\n" => @$loaded_by) . "\n";

ATTRIBUTES
These can be specified at construction, and will be populated during use.

$hashref = $dt->exclude
    A hashref of files/modules to exclude from dep tracking. By default "strict" and "warnings" are excluded.

$hashref = $dt->dep_map
    Every file which is loaded while the tool is started will have an entry in this hash, each value is an array of all files which loaded the key file directly or indirectly.

$hashref = $dt->loaded
    How many times each file was directly loaded.

METHODS

$dt->start
    Start tracking modules which are loaded.

$dt->stop
    Stop tracking moduels that are loaded.

CLASS METHODS

$dt_or_undef = Test2::Harness::Runner::DepTracer->ACTIVE();
    Get the currently active DepTracer, if any.

SOURCE
The source code repository for Test2-Harness can be found at http://github.com/Test-More/Test2-Harness/.

MAINTAINERS

Chad Granum <exodist@cpan.org>

AUTHORS
Chad Granum <exodist@cpan.org>

COPYRIGHT
Copyright 2020 Chad Granum <exodist7@gmail.com>.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

See http://dev.perl.org/licenses/